/* ----------------------------------------------------------------------------
 *  codingSpace17					
 * ----------------------------------------------------------------------------
 *  Typo / Time
 * ----------------------------------------------------------------------------
 *  prog: max.rheiner@zhdk.ch
 * ----------------------------------------------------------------------------
 */
int dayH = 24;
int hourMin = 60;
int minuteSec = 60;
PVector[] secondCircle;
PVector[] minCircle;
PVector[] hCircle;
int rad = 150;

void setup()
{
  size(800, 600);
  
  secondCircle = new PVector[60];
  minCircle = new PVector[60];
  hCircle = new PVector[12];
  
  float j =0.0;
  
  for(int i=0;i< secondCircle.length;i++)
  {
    secondCircle[i] = new PVector(sin(radians(-j))*rad,
                                 cos(radians(-j))*rad,
                                 0);
    j+=6.0;                             
  }
  
  for(int i=0;i< minCircle.length;i++)
  {
    minCircle[i] = new PVector(sin(radians(-j))*rad*.75,
                                 cos(radians(-j))*rad*.75,
                                 0);
    j+=6.0;                             
  }
  
  for(int i=0;i< hCircle.length;i++)
  {
    hCircle[i] = new PVector(sin(radians(-j))*rad*.5,
                                 cos(radians(-j))*rad*.5,
                                 0);
    j+=30.0;                             
  }
  
  smooth();
}

void draw()
{
  background(255); 
  pushMatrix();
  translate(width*.5, height*.5);
  circlePoints();
  
  
  
  
//analog
    pushMatrix();
    noFill();
    stroke(0);
      translate(-200,-100);
      rotate(radians(-90));
    pushMatrix(); // hours
    rotate(radians(map((float)second()+(minute()*60)+hour()*3600,0,43200,0,360)));
    strokeWeight(4);
    line(0,0,50,0);
    popMatrix();
    
    pushMatrix(); // minutes
    rotate(radians(map((float)second()+minute()*60,0,3600,0,360)));
    strokeWeight(2);
    line(0,0,100,0);
    popMatrix();
    
    pushMatrix(); // seconds
    rotate(radians(map((float)second(),0,60,0,360)));
    strokeWeight(1);
    line(0,0,120,0);
    popMatrix();  
  popMatrix();

//ellipse
  pushMatrix();
      translate(0,-100);
      rotate(radians(-90));
      noStroke();
    pushMatrix(); // hours
    fill(#33C5D3, 100);
    ellipse(0, 0, map((float)second()+(minute()*60)+abs(hour()-12)*3600,0,43200,200,0),map((float)second()+(minute()*60)+abs(hour()-12)*3600,0,43200,200,0));
    popMatrix();
    
    pushMatrix(); // minutes
    ellipse(0, 0, map((float)second()+minute()*60,0,3600,200,0),map((float)second()+minute()*60,0,3600,200,0));
    popMatrix();
    
    pushMatrix(); // seconds
    ellipse(0, 0, map((float)second(),0,60,200,0), map((float)second(),0,60,200,0));
    popMatrix();
  popMatrix();

//arc
  pushMatrix();
      translate(200,-100);
      rotate(radians(-90));
      noStroke();
      fill(#33C5D3, 100);
    pushMatrix(); // hours
    strokeWeight(4);
    arc(0, 0, 75, 75, 0, radians(map((float)second()+(minute()*60)+abs(hour()-12)*3600,0,43200,0,360)));
    popMatrix();
    
    pushMatrix(); // minutes
    strokeWeight(2);
    arc(0, 0, 150, 150, 0, radians(map((float)second()+minute()*60,0,3600,0,360)));
    popMatrix();
    
    pushMatrix(); // seconds
    arc(0, 0, 200, 200, 0, radians(map((float)second(),0,60,0,360)));
    strokeWeight(1);
    popMatrix();
  popMatrix();

  
  //rect 2
   pushMatrix();
    translate(-100,100);
    rotate(radians(-90));
      noStroke();
      fill(#33C5D3, 100);
    int high = 50;
    pushMatrix(); // hours
    rectMode(CENTER);
    rect(high,-75, high, map((float)second()+(minute()*60)+abs(hour()-12)*3600,0,43200,0,150));
    popMatrix();
    
    pushMatrix(); // minutes
    strokeWeight(2);
    rect(0,-75,high,map((float)second()+minute()*60,0,3600,0,150));
    popMatrix();
    
    pushMatrix(); // seconds
    rect(-high,-75, high,map((float)second(),0,60,0,150));
    strokeWeight(1);
    popMatrix();
  popMatrix();
  
 popMatrix();
    
 println();
}

void circlePoints(){
  
  stroke(0);
  strokeWeight(5); 
  pushMatrix();  
  translate(100,100);
  rotate(radians(180));

  strokeWeight(1);
  for(int i=0;i< hCircle.length;i++)
  {
    point(hCircle[i].x,
          hCircle[i].y);  
  }


  for(int i=0;i< minCircle.length;i++)
  {
    point(minCircle[i].x,
          minCircle[i].y);  
  }
  

  for(int i=0;i< secondCircle.length;i++)
  {
    point(secondCircle[i].x,
          secondCircle[i].y);  
  }
  
//  int strokeW = 15;
//  strokeWeight(strokeW);
//
//  point(secondCircle[second()].x,secondCircle[second()].y);
  
  noStroke();
  beginShape();
    vertex(secondCircle[second()].x,secondCircle[second()].y);
    vertex(minCircle[minute()].x,minCircle[minute()].y);
    vertex(hCircle[abs(hour()-12)].x,hCircle[abs(hour()-12)].y);
  endShape(CLOSE);
  
  fill(#D6368E,100);
    beginShape();
    vertex(secondCircle[second()].x,secondCircle[second()].y);
    vertex(minCircle[minute()].x,minCircle[minute()].y);
    vertex(0,0);
  endShape(CLOSE);
  
  beginShape();
    vertex(secondCircle[second()].x,secondCircle[second()].y);
    vertex(0,0);
    vertex(hCircle[abs(hour()-12)].x,hCircle[abs(hour()-12)].y);
  endShape(CLOSE);
  
  popMatrix();
}

